<?php

class formWidgetContentMapsisOptions extends cmsForm{

	public function init($options=false){
	
		$cats_list = array();
		$datasets_list = array('0'=>'');
		$fields_list = array(''=>'');
		
		if (!empty($options['ctype_id'])){
			$content_model = cmsCore::getModel('content');	
			$ctype = $content_model->getContentType($options['ctype_id']);
			$cats = $content_model->getCategoriesTree($ctype['name']);

			if ($cats){ 
				foreach($cats as $cat){
					if ($cat['ns_level'] > 1){
						$cat['title'] = str_repeat('-', $cat['ns_level']) . ' ' . $cat['title'];
					}
					$cats_list[$cat['id']] = $cat['title'];

				}
			}
			
			$datasets = $content_model->getContentDatasets($options['ctype_id']);			
			if ($datasets){ $datasets_list = array('0'=>'') + array_collection_to_list($datasets, 'id', 'title'); }
			
			$fields = $content_model->getContentFields($ctype['name']);
			if ($fields){ $fields_list = array(''=>'') + array_collection_to_list($fields, 'name', 'title'); }					
		}

		$cats_list_all = array();
		$datasets_list_all = array('0'=>'');
		$fields_list_all = array(''=>'');
		
		if (!empty($options['ctype_id_all'])){
			$content_model_all = cmsCore::getModel('content');	
			$ctype_all = $content_model_all->getContentType($options['ctype_id_all']);
			$cats_all = $content_model_all->getCategoriesTree($ctype_all['name']);

			if ($cats_all){ 
				foreach($cats_all as $cat_all){
					if ($cat_all['ns_level'] > 1){
						$cat_all['title'] = str_repeat('-', $cat_all['ns_level']) . ' ' . $cat_all['title'];
					}
					$cats_list_all[$cat_all['id']] = $cat_all['title'];

				}
			}
			
			$datasets_all = $content_model_all->getContentDatasets($options['ctype_id_all']);			
			if ($datasets_all){ $datasets_list_all = array('0'=>'') + array_collection_to_list($datasets_all, 'id', 'title'); }
			
			$fields_all = $content_model_all->getContentFields($ctype_all['name']);
			if ($fields_all){ $fields_list_all = array(''=>'') + array_collection_to_list($fields_all, 'name', 'title'); }					
		}

	
        return array(
			array(
				'type' => 'fieldset',
				'title' => 'Карты (одна метка)',
				'childs' => array(
					new fieldMapsis('options:mapsis_coordinates', array(
                        'title' => 'Местоположение',
						'default' => '',
                    )),
					new fieldNumber('options:mapsis_zoom', array(
						'title' => 'Масштаб',
						'default' => 12,
					)),
					new fieldNumber('options:mapsis_height', array(
						'title' => 'Высота',
						'default' => 250,
						'hint' => 'В пикселях. Ширина 100%.',
					)),
					new fieldString('options:mapsis_text', array(
						'title' => 'Текст',
						'default' => '',
						'hint' => 'Свой текст в балуне.',
					)),
					new fieldCheckbox('options:mapsis_google', array(
						'title' => 'Карта Google',
						'default' => 0,
					)),
					new fieldCheckbox('options:mapsis_yandex', array(
						'title' => 'Карта Яндекс',
						'default' => 0,
					)),
					new fieldCheckbox('options:mapsis_weather', array(
						'title' => 'Карта Google (погода)',
						'default' => 0,
					)),
					new fieldCheckbox('options:mapsis_panoramio', array(
						'title' => 'Карта Google (Panoramio)',
						'default' => 0,
					)),
					new fieldCheckbox('options:mapsis_route', array(
						'title' => 'Карта Google (маршрут)',
						'default' => 0,
					)),
					new fieldList('options:mapsis_widget', array(
						'title' => 'Место координат',
						'default' => 0,
						'items' => explode(",", 'Виджет,Поле контента'),
					)),
                    new fieldList('options:ctype_id', array(
                        'title' => 'Тип контента',
                        'generator' => function($item) {
                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();
                            $items = array();
                            if ($tree) {
                                foreach ($tree as $item) {
                                    $items[$item['id']] = $item['title'];
                                }
                            }
                            return $items;
                        },
                    )),
					new fieldList('options:category_id', array(
						'title' => 'Категория',
						'parent' => array(
							'list' => 'options:ctype_id',
							'url' => href_to('content', 'widget_cats_ajax')
						),
						'items' => $cats_list
					)),
                    new fieldList('options:dataset', array(
                        'title' => 'Фильтры из набора',
						'parent' => array(
							'list' => 'options:ctype_id',
							'url' => href_to('content', 'widget_datasets_ajax')
						),
						'items' => $datasets_list
                    )),
                    new fieldList('options:map_field', array(
                        'title' => 'Поле координат',
						'parent' => array(
							'list' => 'options:ctype_id',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list
                    )),
				)
			),
			array(
				'type' => 'fieldset',
				'title' => 'Карты (много меток)',
				'childs' => array(
					new fieldNumber('options:mapsis_zoom_all', array(
						'title' => 'Масштаб',
						'default' => 12,
					)),
					new fieldNumber('options:mapsis_height_all', array(
						'title' => 'Высота',
						'default' => 250,
						'hint' => 'В пикселях. Ширина 100%.',
					)),
					new fieldCheckbox('options:mapsis_google_all', array(
						'title' => 'Карта Google',
						'default' => 0,
					)),
					new fieldCheckbox('options:mapsis_yandex_all', array(
						'title' => 'Карта Яндекс',
						'default' => 0,
					)),
					new fieldList('options:mapsis_all', array(
						'title' => 'Вывод меток',
						'default' => 0,
						'items' => explode(",", 'Последние записи,Случайные записи'),
					)),
                    new fieldList('options:ctype_id_all', array(
                        'title' => 'Тип контента',
                        'generator' => function($item) {
                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();
                            $items = array();
                            if ($tree) {
                                foreach ($tree as $item) {
                                    $items[$item['id']] = $item['title'];
                                }
                            }
                            return $items;
                        },
                    )),
					new fieldList('options:category_id_all', array(
						'title' => 'Категория',
						'parent' => array(
							'list' => 'options:ctype_id_all',
							'url' => href_to('content', 'widget_cats_ajax')
						),
						'items' => $cats_list_all,
					)),
                    new fieldList('options:dataset_all', array(
                        'title' => 'Фильтры из набора',
						'parent' => array(
							'list' => 'options:ctype_id_all',
							'url' => href_to('content', 'widget_datasets_ajax')
						),
						'items' => $datasets_list_all,
                    )),
                    new fieldList('options:map_field_all', array(
                        'title' => 'Поле координат',
						'parent' => array(
							'list' => 'options:ctype_id_all',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list_all,
                    )),
                    new fieldList('options:title_field_all', array(
                        'title' => 'Поле заголовка',
						'parent' => array(
							'list' => 'options:ctype_id_all',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list_all,
						'hint' => 'По умолчанию выводится поле «Заголовок».',
                    )),
                    new fieldList('options:image_field_all', array(
                        'title' => 'Поле изображения',
						'parent' => array(
							'list' => 'options:ctype_id_all',
							'url' => href_to('content', 'widget_fields_ajax')
						),
						'items' => $fields_list_all,
                    )),
                    new fieldNumber('options:limit_all', array(
                        'title' => 'Количество меток',
                        'default' => 1,
                        'rules' => array(
                            array('required')
                        ),
						'hint' => 'При значении 1 выводятся все метки.',
                    )),
				)
			),
        );
	}
}